/****************************************************************
*   Utility routines for Microsoft C                            *
*****************************************************************
*   Miscellaneous Routines (header file)                        *
*                                                               *
*                                     Yudong Yang               *
*     Dept. of Computer Science and Technology, TsingHua Univ.  *
*   File : utility.h                                            *
****************************************************************/
#include <stdio.h>
// utility.c

// strip the white spaces of both sides of a string
// return length of the stripped string
int strstrip(char *str);

// find the first occurance of a char in string
// return the displacement of that char
//  or -1 if not find
// it differs from the standard C library routine strchr by not return a pointer
int strfindc(char * str, char ch);

// get a clean string from file
// return the length of the string
int mfgets(char *buf, FILE *fp);

// append an extention to file if it doesn't contain one
// working only on DOS/Windows systems
void append_extension(char *fname, char *ext);

// replace the old extention of a file name or just append if it doesn't contain one
// working only on DOS/Windows systems
void replace_extension(char *fname, char *ext);

// convert string to upper case
// return the pointer to str
char *str_upr(char *str);

// convert string to lower case
// return the pointer to str
char *str_lwr(char *str);

// convert first n chars of string to upper case
// return the pointer to str
char *strn_upr(char *str, int n);

// convert first n chars of string to lower case
// return the pointer to str
char *strn_lwr(char *str, int n);

// scroll the str left by one char, fill the end with ch
char *str_scroll_left(char * str, char ch);

// scroll the str right by one char, fill the end with ch
char *str_scroll_right(char * str, char ch);